## ovito 2.8.1+dfsg2

=== CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2014) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

PROJECT(Ovito)

# Make sure we have a recent version of CMake.
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.12 FATAL_ERROR)
CMAKE_POLICY(VERSION 2.8.12)

# Choose CMake policies.
CMAKE_POLICY(SET CMP0023 OLD)   # Allow keyword and plain target_link_libraries signatures to be mixed.
CMAKE_POLICY(SET CMP0020 NEW) 	# Automatically link to qtmain.lib on Windows.
IF(NOT CMAKE_VERSION VERSION_LESS "3")
	CMAKE_POLICY(SET CMP0026 OLD)	# Suppress warning when reading the LOCATION target property.
	CMAKE_POLICY(SET CMP0043 OLD)	# Suppress warning because COMPILE_DEFINITIONS_* target property is used.
	CMAKE_POLICY(SET CMP0045 OLD)	# Don't warn about non-existing targets in GET_TARGET_PROPERTY().
ENDIF()

# Check compiler requirement.
IF(CMAKE_CXX_COMPILER_ID STREQUAL MSVC)
	IF(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "18")
		MESSAGE(FATAL_ERROR "OVITO requires Visual C++ 2013 or newer.")
	ENDIF()
ENDIF()

# This is to enable target debugging within Visual Studio Code. 
# It is ignored oustide of Visual Studio Code/CMake tools. 
INCLUDE(CMakeToolsHelpers OPTIONAL)

SET(OVITO_SOURCE_BASE_DIR "${CMAKE_CURRENT_LIST_DIR}")
LIST(APPEND CMAKE_MODULE_PATH ${OVITO_SOURCE_BASE_DIR}/cmake)
INCLUDE(${OVITO_SOURCE_BASE_DIR}/cmake/Version.cmake)
INCLUDE(${OVITO_SOURCE_BASE_DIR}/cmake/Plugins.cmake)
INCLUDE(${OVITO_SOURCE_BASE_DIR}/cmake/PrecompiledHeader.cmake)

# Define build options.
OPTION(OVITO_DOUBLE_PRECISION_FP "Use double-precision floating-point numbers." "OFF")
OPTION(OVITO_BUILD_GUI "Build the graphical user interface." "ON")
OPTION(OVITO_BUILD_APPSTORE_VERSION "Build binaries for the Apple App Store and Windows Store." "OFF")

# Define user options that control the building of OVITO's standard plugins.
OPTION(OVITO_BUILD_PLUGIN_PARTICLES "Build the Particles plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_MESH "Build the Mesh plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_TACHYON "Build the Tachyon renderer plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_CRYSTALANALYSIS "Build the CrystalAnalysis plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_PYSCRIPT "Build the Python scripting plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_NETCDFPLUGIN "Build the NetCDF plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_POVRAY "Build the POV-Ray plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_OPENBABELPLUGIN "Build the OpenBabel plugin (experimental)." "OFF")

# This is a global list of plugin targets that will be built.
# It will get populated by the OVITO_PLUGIN macro.
SET(OVITO_PLUGINS_LIST "")

# Enable software testing framework.
ENABLE_TESTING()

# Activate C++11 language standard.
IF(NOT CMAKE_VERSION VERSION_LESS "3.1")
	SET(CMAKE_CXX_STANDARD 11)
	SET(CMAKE_CXX_STANDARD_REQUIRED ON)
ELSE()
	IF(NOT MSVC)
		IF(CMAKE_COMPILER_IS_GNUCXX)
		    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
		ELSE()
	    	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
		ENDIF()
	ENDIF()
ENDIF()

IF(CYGWIN)
	IF(CMAKE_COMPILER_IS_GNUCXX)
		# Linking fails without -O3
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
	ENDIF()
ENDIF()

IF(APPLE)
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++ -Wno-invalid-offsetof")
ENDIF()

IF(MSVC)
	# Suppress warning related to QVarLengthArray implementation.
	ADD_COMPILE_OPTIONS("/wd4996")
	# Suppress warning on conversion from size_t to int, possible loss of data.
	ADD_COMPILE_OPTIONS("/wd4267")
	# Compiling template code leads to large object files.
	ADD_COMPILE_OPTIONS("/bigobj")	
ENDIF()

IF(UNIX)
	IF(APPLE)
		SET(MACOSX_BUNDLE_NAME "Ovito") 
		SET(MACOSX_BUNDLE_BUNDLE_NAME "${MACOSX_BUNDLE_NAME}") 
		
		# The directory where the main executable goes to.
		SET(OVITO_RELATIVE_BINARY_DIRECTORY ".")
		# The directory where the main libraries go to.
		SET(OVITO_RELATIVE_LIBRARY_DIRECTORY "${MACOSX_BUNDLE_NAME}.app/Contents/MacOS")
		# The directory where the auxiliary files go to.
		SET(OVITO_RELATIVE_SHARE_DIRECTORY "${MACOSX_BUNDLE_NAME}.app/Contents/Resources")
		# The directory where the compiled plugins go to.
		SET(OVITO_RELATIVE_PLUGINS_DIRECTORY "${MACOSX_BUNDLE_NAME}.app/Contents/PlugIns")	
		# The directory where the plugin manifests go to.
		SET(OVITO_RELATIVE_PLUGIN_MANIFESTS_DIRECTORY "${MACOSX_BUNDLE_NAME}.app/Contents/Resources/plugins")	
		# The directory where the plugins' Python files go to.
		SET(OVITO_RELATIVE_PLUGIN_PYTHON_DIRECTORY "${MACOSX_BUNDLE_NAME}.app/Contents/Resources/plugins/python")	
	ELSE()
		# The directory where the main executable goes to.
		SET(OVITO_RELATIVE_BINARY_DIRECTORY "bin")
		# The directory where the main libraries go to.
		SET(OVITO_RELATIVE_LIBRARY_DIRECTORY "lib/ovito")
		# The directory where the auxiliary files go to.
		SET(OVITO_RELATIVE_SHARE_DIRECTORY "share/ovito")
		# The directory where the compiled plugins go to.
		SET(OVITO_RELATIVE_PLUGINS_DIRECTORY "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins")
		# The directory where the plugin manifests go to.
		SET(OVITO_RELATIVE_PLUGIN_MANIFESTS_DIRECTORY "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
		# The directory where the plugins' Python files go to.
		SET(OVITO_RELATIVE_PLUGIN_PYTHON_DIRECTORY "${OVITO_RELATIVE_PLUGINS_DIRECTORY}/python")	
	ENDIF()
ELSE()
	# The directory where the main executable goes to.
	SET(OVITO_RELATIVE_BINARY_DIRECTORY ".")
	# The directory where the main libraries go to.
	SET(OVITO_RELATIVE_LIBRARY_DIRECTORY ".")
	# The directory where the auxiliary files go to.
	SET(OVITO_RELATIVE_SHARE_DIRECTORY ".")
	# The directory where the compiled plugins go to.
	SET(OVITO_RELATIVE_PLUGINS_DIRECTORY "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins")
	# The directory where the plugin manifests go to.
	SET(OVITO_RELATIVE_PLUGIN_MANIFESTS_DIRECTORY "${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
	# The directory where the plugins' Python files go to.
	SET(OVITO_RELATIVE_PLUGIN_PYTHON_DIRECTORY "${OVITO_RELATIVE_PLUGINS_DIRECTORY}/python")	
ENDIF()

# Controls whether a static or a shared OVITO executable is built.
# In a static build, all plugins (and most third-party libraries) are linked into one big executable,
# which makes distribution easier. In a shared build, plugins are built as shared objects (dynamic link libraries)
# and it becomes possible to add or remove plugins after distribution.
IF(UNIX AND NOT APPLE AND CMAKE_COMPILER_IS_GNUCXX)
	OPTION(OVITO_MONOLITHIC_BUILD "Create one big executable that contains all plugins and third-party libraries." "OFF")
ENDIF()
IF(NOT OVITO_MONOLITHIC_BUILD)
    SET(OVITO_DEFAULT_LIBRARY_TYPE SHARED)
    
	# Add the automatically determined parts of the RPATH,
	# which point to directories outside the build tree to the install RPATH
	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
	    
ELSE()
    SET(OVITO_DEFAULT_LIBRARY_TYPE STATIC)
ENDIF()

# The directory where the main executable goes to.
SET(OVITO_BINARY_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_BINARY_DIRECTORY}")
# The directory where the main libraries go to.
SET(OVITO_LIBRARY_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_LIBRARY_DIRECTORY}")
# The directory where the compiled plugins go to.
SET(OVITO_PLUGINS_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
# The directory where the plugin manifests go to.
SET(OVITO_PLUGIN_MANIFESTS_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_PLUGIN_MANIFESTS_DIRECTORY}")
# The directory where the plugins' Python files go to.
SET(OVITO_PLUGIN_PYTHON_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_PLUGIN_PYTHON_DIRECTORY}")
# The directory where the auxiliary files go to.
SET(OVITO_SHARE_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_SHARE_DIRECTORY}")

# This is the name suffix used for generating plugin libraries.
SET(OVITO_PLUGIN_LIBRARY_SUFFIX ${CMAKE_SHARED_LIBRARY_SUFFIX})
IF(APPLE)
	# On Mac OS, we use the .so extension instead of the standard .dylib to be compatible
	# with the Python interpreter, which only finds modules having a .so suffix.
	SET(OVITO_PLUGIN_LIBRARY_SUFFIX ".so")
ENDIF()

# This macro installs a required third-party DLL in the OVITO directory
# so that it can be distributed together with the program.
MACRO(OVITO_INSTALL_DLL dll)
	MESSAGE("Deploying DLL ${dll}.")
	EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" "-E" "copy_if_different" "${dll}" "${OVITO_BINARY_DIRECTORY}" RESULT_VARIABLE error_var)
	IF(error_var)
		MESSAGE(FATAL_ERROR "Failed to copy DLL into build directory: ${dll}")
	ENDIF()
	INSTALL(FILES "${dll}" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}")
ENDMACRO()

# This macro installs a required third-party shared library in the OVITO directory
# so that it can be distributed together with the program.
MACRO(OVITO_INSTALL_SHARED_LIB shared_lib destination_dir)
	FILE(MAKE_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${destination_dir}")
	# Strip version number from shared lib filename.
	GET_FILENAME_COMPONENT(shared_lib_ext "${shared_lib}" EXT)
	STRING(REPLACE ${shared_lib_ext} ".so" shared_lib_new "${shared_lib}")
	FILE(GLOB lib_versions "${shared_lib_new}*")
	FOREACH(lib_version ${lib_versions})
		IF(IS_SYMLINK ${lib_version})
			GET_FILENAME_COMPONENT(symlink_target "${lib_version}" REALPATH)
			GET_FILENAME_COMPONENT(symlink_target_name "${symlink_target}" NAME)
			GET_FILENAME_COMPONENT(lib_version_name "${lib_version}" NAME)
			MESSAGE("Installing symlink ${lib_version} to shared library ${symlink_target}")
			EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -E create_symlink ${symlink_target_name} "${${PROJECT_NAME}_BINARY_DIR}/${destination_dir}/${lib_version_name}")
		ELSE()
			MESSAGE("Installing shared library ${lib_version}")
			CONFIGURE_FILE("${lib_version}" "${${PROJECT_NAME}_BINARY_DIR}/${destination_dir}/" COPYONLY)
		ENDIF()
		INSTALL(FILES "${lib_version}" DESTINATION "${destination_dir}/")
	ENDFOREACH()
ENDMACRO()

# Tell CMake to run Qt moc whenever necessary.
SET(CMAKE_AUTOMOC ON)
# As moc files are generated in the binary dir, tell CMake to always look for includes there.
SET(CMAKE_INCLUDE_CURRENT_DIR ON)
  
# Find and set up Qt5 libraries.
FOREACH(component IN ITEMS Core Concurrent Network Gui)
	FIND_PACKAGE(Qt5${component} REQUIRED)
ENDFOREACH()
IF(OVITO_BUILD_GUI) 
	FOREACH(component IN ITEMS Widgets PrintSupport)
		FIND_PACKAGE(Qt5${component} REQUIRED)
	ENDFOREACH()
	IF(UNIX AND NOT APPLE AND CMAKE_COMPILER_IS_GNUCXX)
		# This is an indirect dependency:
		FIND_PACKAGE(Qt5DBus REQUIRED)
	ENDIF()
ENDIF()

# Find the Boost library.
FIND_PACKAGE(Boost REQUIRED)
IF(NOT Boost_FOUND)
	MESSAGE(FATAL_ERROR "The Boost library could not be found on your system. ${Boost_ERROR_REASON}")
ENDIF()

# Generate build targets.
ADD_SUBDIRECTORY(src)

# Gnerate user documentation.
INCLUDE(cmake/Documentation.cmake)

# Set up CPack for generating distributable program packages.
INCLUDE(cmake/Packaging.cmake)

# Export our targets so that external plugins can use them.
CONFIGURE_FILE(cmake/OVITOConfig.cmake "${${PROJECT_NAME}_BINARY_DIR}/" @ONLY)
IF(NOT CMAKE_VERSION VERSION_LESS "3")
	EXPORT(EXPORT OVITO NAMESPACE "Ovito::" FILE OVITOTargets.cmake)
ENDIF()

=== src/gui/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2016) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

SET(SourceFiles 
	mainwin/MainWindow.cpp
	mainwin/ViewportsPanel.cpp
	mainwin/TaskDisplayWidget.cpp
	mainwin/cmdpanel/CommandPanel.cpp
	mainwin/cmdpanel/RenderCommandPage.cpp
	mainwin/cmdpanel/ModifyCommandPage.cpp
	mainwin/cmdpanel/ModificationListModel.cpp
	mainwin/cmdpanel/ModificationListItem.cpp
	mainwin/cmdpanel/ModifierListBox.cpp
	mainwin/cmdpanel/UtilityCommandPage.cpp
	mainwin/cmdpanel/OverlayCommandPage.cpp
	dialogs/AdjustCameraDialog.cpp
	dialogs/AnimationKeyEditorDialog.cpp
	dialogs/AnimationSettingsDialog.cpp
	dialogs/ApplicationSettingsDialog.cpp
	dialogs/GeneralSettingsPage.cpp
	dialogs/ViewportSettingsPage.cpp
	dialogs/HistoryFileDialog.cpp
	dialogs/ImportFileDialog.cpp
	dialogs/ImportRemoteFileDialog.cpp
	dialogs/SaveImageFileDialog.cpp
	dialogs/LoadImageFileDialog.cpp
	dialogs/RemoteAuthenticationDialog.cpp
	dialogs/FileExporterSettingsDialog.cpp
	actions/ActionManager.cpp
	actions/FileActions.cpp
	actions/ViewportActions.cpp
	actions/AnimationActions.cpp
	actions/RenderActions.cpp
	actions/ViewportModeAction.cpp
	dataset/importexport/FileSourceEditor.cpp
	dataset/importexport/FileImporterEditor.cpp
	dataset/importexport/AttributeFileExporterEditor.cpp
	dataset/GuiDataSetContainer.cpp
	widgets/general/RolloutContainer.cpp
	widgets/general/SpinnerWidget.cpp
	widgets/general/ColorPickerWidget.cpp
	widgets/general/ElidedTextLabel.cpp
	widgets/general/AutocompleteLineEdit.cpp
	widgets/general/AutocompleteTextEdit.cpp
	widgets/general/HtmlListWidget.cpp
	widgets/animation/AnimationTimeSpinner.cpp
	widgets/animation/AnimationFramesToolButton.cpp
	widgets/animation/AnimationTimeSlider.cpp
	widgets/animation/AnimationTrackBar.cpp
	widgets/rendering/FrameBufferWidget.cpp
	widgets/rendering/FrameBufferWindow.cpp
	widgets/selection/SceneNodesListModel.cpp
	widgets/selection/SceneNodeSelectionBox.cpp
	widgets/display/CoordinateDisplayWidget.cpp
	widgets/display/StatusWidget.cpp
	plugins/utility/UtilityApplet.cpp
	plugins/autostart/GuiAutoStartObject.cpp
	properties/PropertiesEditor.cpp
	properties/PropertiesPanel.cpp
	properties/ParameterUI.cpp
	properties/NumericalParameterUI.cpp
	properties/AffineTransformationParameterUI.cpp
	properties/BooleanActionParameterUI.cpp
	properties/BooleanGroupBoxParameterUI.cpp
	properties/BooleanParameterUI.cpp
	properties/BooleanRadioButtonParameterUI.cpp
	properties/ColorParameterUI.cpp
	properties/CustomParameterUI.cpp
	properties/FilenameParameterUI.cpp
	properties/FloatParameterUI.cpp
	properties/FontParameterUI.cpp
	properties/IntegerParameterUI.cpp
	properties/IntegerRadioButtonParameterUI.cpp
	properties/RefTargetListParameterUI.cpp
	properties/StringParameterUI.cpp
	properties/SubObjectParameterUI.cpp
	properties/VariantComboBoxParameterUI.cpp
	properties/Vector3ParameterUI.cpp
	rendering/ViewportSceneRenderer.cpp
	rendering/StandardSceneRenderer.cpp
	rendering/StandardSceneRendererEditor.cpp
	rendering/RenderSettingsEditor.cpp
	viewport/ViewportWindow.cpp
	viewport/ViewportMenu.cpp
	viewport/input/ViewportInputManager.cpp
	viewport/input/ViewportInputMode.cpp
	viewport/input/NavigationModes.cpp
	viewport/input/XFormModes.cpp
	viewport/picking/PickingSceneRenderer.cpp
	viewport/overlay/CoordinateTripodOverlayEditor.cpp
	viewport/overlay/TextLabelOverlayEditor.cpp
	viewport/overlay/MoveOverlayInputMode.cpp
	app/GuiApplication.cpp
	scene/objects/camera/CameraObjectEditor.cpp
	scene/objects/geometry/TriMeshDisplayEditor.cpp
	utilities/io/GuiFileManager.cpp
	animation/controller/TCBInterpolationControllerEditor.cpp
)

# Compile resources.
QT5_ADD_RESOURCES(ResourceFiles resources/gui.qrc)

# Build library
ADD_LIBRARY(Gui SHARED GUI.cpp ${SourceFiles} ${ResourceFiles})

# Set default include directory.
TARGET_INCLUDE_DIRECTORIES(Gui PUBLIC "$<BUILD_INTERFACE:${OVITO_SOURCE_BASE_DIR}/src>")

# GUI is based on Core and the OpenGL rendering library.
TARGET_LINK_LIBRARIES(Gui PUBLIC Core OpenGLRenderer)

# Link Qt5.
TARGET_LINK_LIBRARIES(Gui PUBLIC Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Network)

# Pass version information to source code.
SET_SOURCE_FILES_PROPERTIES("app/Application.cpp" PROPERTIES COMPILE_DEFINITIONS 
    "OVITO_VERSION_MAJOR=${OVITO_VERSION_MAJOR};OVITO_VERSION_MINOR=${OVITO_VERSION_MINOR};OVITO_VERSION_REVISION=${OVITO_VERSION_REVISION};OVITO_VERSION_STRING=\"${OVITO_VERSION_STRING}\"")

# Speed up compilation by using precompiled headers.
ADD_PRECOMPILED_HEADER(Gui gui/GUI.h)

IF(APPLE)
    # Activate @rpath on MacOS.
    SET_TARGET_PROPERTIES(Gui PROPERTIES MACOSX_RPATH TRUE)
	# This is required to avoid error by install_name_tool on MacOS.
	SET_TARGET_PROPERTIES(Gui PROPERTIES LINK_FLAGS "-headerpad_max_install_names")
ELSEIF(UNIX)
    SET_TARGET_PROPERTIES(Gui PROPERTIES INSTALL_RPATH "$ORIGIN")
ENDIF()
    
# This library is part of the installation package.
INSTALL(TARGETS Gui EXPORT OVITO
	RUNTIME DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}"
	LIBRARY DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}")

# Export target to make it accessible for external plugins.
IF(CMAKE_VERSION VERSION_LESS "3")
	EXPORT(TARGETS Gui NAMESPACE "Ovito::" APPEND FILE "${${PROJECT_NAME}_BINARY_DIR}/OVITOTargets.cmake")
ENDIF()

=== src/main/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2013) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Include the resource in the Win32 executable.
IF(WIN32)
	SET(WINDOWS_RESOURCES resources/ovito.rc)
ENDIF(WIN32)

IF(CMAKE_BUILD_TYPE STREQUAL "Release")
	# This will create a GUI application on Windows platform.
	SET(OVITO_WIN32_EXECUTABLE "WIN32")
ELSE()
	# This will create a console application on Windows platform.
	SET(OVITO_WIN32_EXECUTABLE "")
ENDIF()

# Builds the main executable of the application
ADD_EXECUTABLE(${PROJECT_NAME} ${OVITO_WIN32_EXECUTABLE} MACOSX_BUNDLE Main.cpp ${WINDOWS_RESOURCES})

# The executable depends on the core and the gui modules, of course.
TARGET_LINK_LIBRARIES(${PROJECT_NAME} Core Gui)

# Put the executable into the right directory.
SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${OVITO_BINARY_DIRECTORY}")

# Set name of executable.
SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES OUTPUT_NAME "ovito")

# Link Qt5.
TARGET_LINK_LIBRARIES(${PROJECT_NAME} Qt5::Core Qt5::Gui)

IF(APPLE)
    # Enable the use of @rpath on OSX.
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES MACOSX_RPATH TRUE)
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES INSTALL_RPATH "@executable_path/")
ELSEIF(UNIX)
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES INSTALL_RPATH "$ORIGIN/../lib/ovito/")
ENDIF()

# This executable will be part of the installation package.
INSTALL(TARGETS ${PROJECT_NAME} DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/")

# Build all plugins first before building the main executable.
FOREACH(plugin ${OVITO_PLUGIN_LIST})
    ADD_DEPENDENCIES(${PROJECT_NAME} ${plugin})
ENDFOREACH()

# Install fonts required by 'minimal' platform plugin on Linux
IF(UNIX AND NOT APPLE)
    INSTALL(DIRECTORY "resources/fonts" DESTINATION "${OVITO_RELATIVE_SHARE_DIRECTORY}/")
ENDIF()

IF(UNIX AND NOT APPLE AND OVITO_MONOLITHIC_BUILD)
	# Install copies of the Qt libraries.
	FOREACH(component IN ITEMS Core Gui Widgets Concurrent Network PrintSupport)
		GET_TARGET_PROPERTY(lib Qt5::${component} LOCATION)
		GET_TARGET_PROPERTY(lib_soname Qt5::${component} IMPORTED_SONAME_RELEASE)
		CONFIGURE_FILE("${lib}" "${OVITO_LIBRARY_DIRECTORY}" COPYONLY)		
		GET_FILENAME_COMPONENT(lib_realname "${lib}" NAME)
		EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -E create_symlink ${lib_realname} "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/${lib_soname}")
		INSTALL(FILES "${lib}" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/")
		INSTALL(FILES "${OVITO_LIBRARY_DIRECTORY}/${lib_soname}" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/")
		GET_FILENAME_COMPONENT(QtBinaryPath ${lib} PATH)
	ENDFOREACH()

	# Create a qt.conf file.
	# This is required to let Qt search for its plugin modules in the program directory.
	INSTALL(CODE "
	    file(WRITE \"\${CMAKE_INSTALL_PREFIX}/${OVITO_RELATIVE_BINARY_DIRECTORY}/qt.conf\" \"[Paths]\\nPlugins = ../${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins_qt/\")
	    " COMPONENT Runtime)

	# Install Qt plugins.
	INSTALL(DIRECTORY "${QtBinaryPath}/../plugins/platforms" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins_qt/")
	INSTALL(DIRECTORY "${QtBinaryPath}/../plugins/bearer" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins_qt/")
	INSTALL(DIRECTORY "${QtBinaryPath}/../plugins/imageformats" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins_qt/" PATTERN "libqsvg.so" EXCLUDE)
	IF(Qt5Core_VERSION VERSION_LESS "5.4")
		INSTALL(DIRECTORY "${QtBinaryPath}/../plugins/accessible" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins_qt/")
	ENDIF()
	IF(NOT Qt5Core_VERSION VERSION_LESS "5.6")
		INSTALL(DIRECTORY "${QtBinaryPath}/../plugins/xcbglintegrations" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins_qt/")
		OVITO_INSTALL_SHARED_LIB("${QtBinaryPath}/libQt5DBus.so" "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/lib")
		OVITO_INSTALL_SHARED_LIB("${QtBinaryPath}/libQt5XcbQpa.so" "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/lib")
	ENDIF()

	# Make the executable look in lib/ovito/ directory for shared libraries.
	SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES INSTALL_RPATH "\$ORIGIN/../lib/ovito")
	SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES BUILD_WITH_INSTALL_RPATH "1")
	FIND_LIBRARY(OVITO_LIBSTDCXX NAMES libstdc++.so.6 PATHS /usr/lib /usr/lib/x86_64-linux-gnu NO_DEFAULT_PATH)
	IF(NOT OVITO_LIBSTDCXX)
		MESSAGE(FATAL_ERROR "Please specify the location of the C++ standard library with the OVITO_LIBSTDCXX option.") 
	ENDIF()
	GET_FILENAME_COMPONENT(OVITO_LIBSTDCXX_REAL ${OVITO_LIBSTDCXX} REALPATH)
	INSTALL(FILES "${OVITO_LIBSTDCXX}" "${OVITO_LIBSTDCXX_REAL}" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/")

ENDIF()

# On Windows, the third-party library DLLs need to be installed in the OVITO directory.
IF(WIN32)
	# Gather Qt dynamic link libraries.
	FOREACH(component IN ITEMS Core Gui Widgets Concurrent Network PrintSupport)
		GET_TARGET_PROPERTY(dll Qt5::${component} LOCATION_${CMAKE_BUILD_TYPE})
		OVITO_INSTALL_DLL("${dll}")
		IF(${component} MATCHES "Core")
			GET_FILENAME_COMPONENT(QtBinaryPath ${dll} PATH)
			IF(Qt5Core_VERSION VERSION_LESS "5.6")
				OVITO_INSTALL_DLL("${QtBinaryPath}/icudt53.dll")
				OVITO_INSTALL_DLL("${QtBinaryPath}/icuin53.dll")
				OVITO_INSTALL_DLL("${QtBinaryPath}/icuuc53.dll")
			ELSEIF(Qt5Core_VERSION VERSION_LESS "5.7")
				OVITO_INSTALL_DLL("${QtBinaryPath}/icudt54.dll")
				OVITO_INSTALL_DLL("${QtBinaryPath}/icuin54.dll")
				OVITO_INSTALL_DLL("${QtBinaryPath}/icuuc54.dll")
			ENDIF()
		ENDIF()
	ENDFOREACH()
	
	# Install Qt plugins.
	IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
		INSTALL(FILES "${QtBinaryPath}/../plugins/platforms/qwindowsd.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/platforms/")
		INSTALL(FILES "${QtBinaryPath}/../plugins/imageformats/qjpegd.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/imageformats/")
		INSTALL(FILES "${QtBinaryPath}/../plugins/imageformats/qgifd.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/imageformats/")
    	IF(Qt5Core_VERSION VERSION_LESS "5.4")
	    	INSTALL(FILES "${QtBinaryPath}/../plugins/accessible/qtaccessiblewidgetsd.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/accessible/")
	    ENDIF()
	ELSE()
		INSTALL(FILES "${QtBinaryPath}/../plugins/platforms/qwindows.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/platforms/")
		INSTALL(FILES "${QtBinaryPath}/../plugins/imageformats/qjpeg.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/imageformats/")
		INSTALL(FILES "${QtBinaryPath}/../plugins/imageformats/qgif.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/imageformats/")
    	IF(Qt5Core_VERSION VERSION_LESS "5.4")
    		INSTALL(FILES "${QtBinaryPath}/../plugins/accessible/qtaccessiblewidgets.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/accessible/")
    	ENDIF()
	ENDIF()
	
	# Create a qt.conf file.
	# This is required to let Qt search for its plugin modules in the program directory.
	INSTALL(CODE "
	    file(WRITE \"\${CMAKE_INSTALL_PREFIX}/${OVITO_RELATIVE_BINARY_DIRECTORY}/qt.conf\" \"[Paths]\\nPlugins = plugins/\")
	    " COMPONENT Runtime)

ENDIF()

# Fix Mac app bundle.
INCLUDE(${OVITO_SOURCE_BASE_DIR}/cmake/FixupMacBundle.cmake)

=== src/3rdparty/qssh/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2013) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Build library
ADD_LIBRARY(QSsh ${OVITO_DEFAULT_LIBRARY_TYPE}
	sftpchannel.cpp
	sftpdefs.cpp
	sftpincomingpacket.cpp
	sftpoperation.cpp
	sftpoutgoingpacket.cpp
	sftppacket.cpp
	sshcapabilities.cpp
	sshchannel.cpp
	sshchannelmanager.cpp
	sshconnection.cpp
	sshconnectionmanager.cpp
	sshcryptofacility.cpp
	sshincomingpacket.cpp
	sshkeyexchange.cpp
	sshkeygenerator.cpp
	sshkeypasswordretriever.cpp
	sshoutgoingpacket.cpp
	sshpacket.cpp
	sshpacketparser.cpp
	sshremoteprocess.cpp
	sshremoteprocessrunner.cpp
	sshsendfacility.cpp
	sshhostkeydatabase.cpp
	sshdirecttcpiptunnel.cpp
	sshinit.cpp
)

# Export symbols when building a Windows DLL.
TARGET_COMPILE_DEFINITIONS(QSsh PRIVATE QSSH_LIBRARY)

# Link to Botan library.
TARGET_LINK_LIBRARIES(QSsh PRIVATE Botan)

# Link to Qt5.
TARGET_LINK_LIBRARIES(QSsh PUBLIC Qt5::Core Qt5::Network)

# Make header files of this library available to dependent targets.
TARGET_INCLUDE_DIRECTORIES(QSsh PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>")

# Make this library part of the installation package.
IF(NOT OVITO_MONOLITHIC_BUILD)
	INSTALL(TARGETS QSsh EXPORT OVITO
		RUNTIME DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}"
		LIBRARY DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}")
ENDIF()

SET_TARGET_PROPERTIES(QSsh  PROPERTIES MACOSX_RPATH TRUE)

# Export target to make it accessible for external plugins.
IF(CMAKE_VERSION VERSION_LESS "3")
	EXPORT(TARGETS QSsh NAMESPACE "Ovito::" FILE "${${PROJECT_NAME}_BINARY_DIR}/OVITOTargets.cmake")
ENDIF()

=== src/plugins/pyscript/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2014) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

SET(Python_ADDITIONAL_VERSIONS "3.4" "3.5" "3.6")
FIND_PACKAGE(PythonLibs REQUIRED)

IF(MSVC)
	# Precompiled headers require more compiler memory.
	ADD_COMPILE_OPTIONS(-Zm150)
ENDIF()

SET(SourceFiles
	engine/ScriptEngine.cpp
	engine/ScriptAutostarter.cpp
	binding/PythonInterface.cpp
	binding/ViewportBinding.cpp
	binding/AnimationBinding.cpp
	binding/SceneBinding.cpp
	binding/FileIOBinding.cpp
	binding/RenderingBinding.cpp
	binding/AppBinding.cpp
	extensions/PythonViewportOverlay.cpp
	extensions/PythonScriptModifier.cpp
)

OVITO_STANDARD_PLUGIN(PyScript
	SOURCES PyScript.cpp ${SourceFiles}
	LIB_DEPENDENCIES ${PYTHON_LIBRARIES} 
	PYTHON_WRAPPERS "${CMAKE_CURRENT_SOURCE_DIR}/python/"
)

# Add Python include directory.
TARGET_INCLUDE_DIRECTORIES(PyScript PUBLIC ${PYTHON_INCLUDE_PATH})

# Speed up compilation by using precompiled headers.
ADD_PRECOMPILED_HEADER(PyScript plugins/pyscript/PyScript.h)

# Install the Python source files that belong to the plugin and which provide the scripting interface.
INSTALL(DIRECTORY "${OVITO_PLUGIN_PYTHON_DIRECTORY}/" 
		DESTINATION "${OVITO_RELATIVE_PLUGIN_PYTHON_DIRECTORY}/"
		REGEX "__pycache__" EXCLUDE)

# Build corresponding GUI plugin.
IF(OVITO_BUILD_GUI)
	ADD_SUBDIRECTORY(gui)
ENDIF()

# Build the script launcher executable.
ADD_EXECUTABLE(ovitos launcher/Main.cpp)
TARGET_LINK_LIBRARIES(ovitos Core Gui)
TARGET_LINK_LIBRARIES(ovitos Qt5::Core Qt5::Gui)
IF(APPLE)
	SET_TARGET_PROPERTIES(ovitos PROPERTIES OUTPUT_NAME "ovitos.exe")
	SET_TARGET_PROPERTIES(ovitos PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${OVITO_LIBRARY_DIRECTORY}")
	INSTALL(TARGETS ovitos DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}")
	SET(OVITOS_EXECUTABLE "${OVITO_LIBRARY_DIRECTORY}/ovitos.exe")
	
	# Install the launch helper script.
	INSTALL(PROGRAMS "resources/ovitos" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}")
ELSE()
	SET_TARGET_PROPERTIES(ovitos PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${OVITO_BINARY_DIRECTORY}")
	INSTALL(TARGETS ovitos DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}")
	GET_PROPERTY(OVITOS_EXECUTABLE TARGET ovitos PROPERTY LOCATION)
ENDIF()
SET(OVITOS_EXECUTABLE "${OVITOS_EXECUTABLE}" PARENT_SCOPE)
IF(APPLE)
    SET_TARGET_PROPERTIES(ovitos PROPERTIES MACOSX_RPATH TRUE)
    SET_TARGET_PROPERTIES(ovitos PROPERTIES INSTALL_RPATH "@executable_path/")
ELSEIF(UNIX)
    SET_TARGET_PROPERTIES(ovitos PROPERTIES INSTALL_RPATH "$ORIGIN/../lib/ovito/")
ENDIF()
# Build the script launcher together with PyScript plugin.
ADD_DEPENDENCIES(PyScript ovitos)

# Install standard Python packages. 
IF(APPLE)
	STRING(REGEX MATCH "[0-9]+\\.[0-9]+" PYTHON_MAJORMINOR_VERSION ${PYTHONLIBS_VERSION_STRING})
	LIST(GET PYTHON_LIBRARIES 0 PYTHON_FIRST_LIBRARY)
	GET_FILENAME_COMPONENT(PYTHON_LIBRARY_PATH "${PYTHON_FIRST_LIBRARY}" PATH)
	INSTALL(DIRECTORY "${PYTHON_LIBRARY_PATH}/python${PYTHON_MAJORMINOR_VERSION}" 
		DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/../Frameworks/Python.framework/Versions/${PYTHON_MAJORMINOR_VERSION}/lib/"
		PATTERN "*.pyc" EXCLUDE 
		PATTERN "*.pyo" EXCLUDE 
		PATTERN "__pycache__" EXCLUDE
		PATTERN "test" EXCLUDE
		PATTERN "*.exe" EXCLUDE
		PATTERN "sphinx" EXCLUDE)
		
	# Install Python header files.
	INSTALL(DIRECTORY "${PYTHON_INCLUDE_PATH}" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/../Frameworks/Python.framework/Versions/${PYTHON_MAJORMINOR_VERSION}/include/")

ELSEIF(UNIX)
	IF(OVITO_MONOLITHIC_BUILD)

		# Install standard Python packages. 
		STRING(REGEX MATCH "[0-9]+\\.[0-9]+" PYTHON_MAJORMINOR_VERSION ${PYTHONLIBS_VERSION_STRING})
		LIST(GET PYTHON_LIBRARIES 0 PYTHON_FIRST_LIBRARY)
		GET_FILENAME_COMPONENT(PYTHON_LIBRARY_PATH "${PYTHON_LIBRARY}" PATH)
		INSTALL(DIRECTORY "${PYTHON_LIBRARY_PATH}/python${PYTHON_MAJORMINOR_VERSION}" 
			DESTINATION "lib/"
			PATTERN "*.pyc" EXCLUDE 
			PATTERN "*.pyo" EXCLUDE 
			PATTERN "__pycache__" EXCLUDE
			PATTERN "test" EXCLUDE
			PATTERN "sphinx" EXCLUDE
			PATTERN "Sphinx*" EXCLUDE
			PATTERN "Jinja*" EXCLUDE
			PATTERN "Pygments*" EXCLUDE
			PATTERN "Babel" EXCLUDE)

		# Install Python header files.
		INSTALL(DIRECTORY "${PYTHON_INCLUDE_PATH}" DESTINATION "include/")

		# Install a copy of libpython.so shared library.
		CONFIGURE_FILE("${PYTHON_LIBRARIES}" "${OVITO_LIBRARY_DIRECTORY}" COPYONLY)
		INSTALL(FILES "${PYTHON_LIBRARIES}" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/")

		# Also install copies of shared libraries that are required by Python modules.
		SET(OVITO_PYTHON_DEPENDENCIES libssl.so libcrypto.so liblapack.so.3gf libblas.so.3gf libquadmath.so.0 libgfortran.so.3 libncurses.so libsqlite3.so.0)
		FOREACH(PYTHON_DEPENDENCY ${OVITO_PYTHON_DEPENDENCIES})
			FIND_LIBRARY(OVITO_PYTHON_DEP NAMES ${PYTHON_DEPENDENCY} PATHS /usr/lib /usr/local/lib /usr/lib/x86_64-linux-gnu NO_DEFAULT_PATH)
			IF(NOT OVITO_PYTHON_DEP)
				MESSAGE(FATAL_ERROR "Could not find shared library ${PYTHON_DEPENDENCY}, which is required by Python interpreter, in system path.")
			ENDIF()
			GET_FILENAME_COMPONENT(OVITO_PYTHON_DEP_REAL ${OVITO_PYTHON_DEP} REALPATH)
			INSTALL(FILES "${OVITO_PYTHON_DEP_REAL}" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/")
			IF(NOT "${OVITO_PYTHON_DEP_REAL}" STREQUAL "${OVITO_PYTHON_DEP}")
				GET_FILENAME_COMPONENT(OVITO_PYTHON_DEP_REAL_NAME ${OVITO_PYTHON_DEP_REAL} NAME)
				EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -E create_symlink ${OVITO_PYTHON_DEP_REAL_NAME} "${CMAKE_CURRENT_BINARY_DIR}/${PYTHON_DEPENDENCY}")
				INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PYTHON_DEPENDENCY} DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/")
			ENDIF()
			UNSET(OVITO_PYTHON_DEP CACHE)
		ENDFOREACH()
	ENDIF()
ELSEIF(WIN32)
	# Install standard Python packages. 
	LIST(GET PYTHON_LIBRARIES 0 PYTHON_FIRST_LIBRARY)
	IF(PYTHON_FIRST_LIBRARY STREQUAL "optimized")
		LIST(GET PYTHON_LIBRARIES 1 PYTHON_FIRST_LIBRARY)
	ENDIF()
	GET_FILENAME_COMPONENT(PYTHON_LIBRARY_PATH "${PYTHON_FIRST_LIBRARY}" PATH)
	GET_FILENAME_COMPONENT(PYTHON_LIBRARY_NAME "${PYTHON_FIRST_LIBRARY}" NAME_WE)
	INSTALL(DIRECTORY "${PYTHON_LIBRARY_PATH}/../Lib" 
		DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}"
		PATTERN "*.pyc" EXCLUDE 
		PATTERN "*.pyo" EXCLUDE
		PATTERN "__pycache__" EXCLUDE)
	# Also install the compiled modules that are shipped with Python.
	INSTALL(DIRECTORY "${PYTHON_LIBRARY_PATH}/../DLLs"
		DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}")

	# Install Python interpreter dll.
	OVITO_INSTALL_DLL("${PYTHON_LIBRARY_PATH}/../${PYTHON_LIBRARY_NAME}.dll")

	# Install Visual C++ runtime needed by Python interpreter.
	OVITO_INSTALL_DLL("${PYTHON_LIBRARY_PATH}/../msvcr100.dll")
ENDIF()

# Define tests for the scripting interface.
SET(PYTHON_TEST_SCRIPTS_DIR "${CMAKE_SOURCE_DIR}/tests/scripts/test_suite")
FILE(GLOB_RECURSE PYTHON_TEST_SCRIPTS RELATIVE "${PYTHON_TEST_SCRIPTS_DIR}" "${PYTHON_TEST_SCRIPTS_DIR}/*.py")
FOREACH(test_script ${PYTHON_TEST_SCRIPTS})
	ADD_TEST(NAME "${test_script}" WORKING_DIRECTORY "${PYTHON_TEST_SCRIPTS_DIR}" COMMAND "${OVITOS_EXECUTABLE}" "${test_script}")
ENDFOREACH()

# Also test example snippets that are part of user documentation.
SET(PYTHON_EXAMPLE_SNIPPETS_DIR "${CMAKE_SOURCE_DIR}/doc/python/example_snippets")
FILE(GLOB_RECURSE PYTHON_EXAMPLE_SNIPPETS RELATIVE "${PYTHON_EXAMPLE_SNIPPETS_DIR}" "${PYTHON_EXAMPLE_SNIPPETS_DIR}/*.py")
FOREACH(test_script ${PYTHON_EXAMPLE_SNIPPETS})
	ADD_TEST(NAME "snippet_${test_script}" WORKING_DIRECTORY "${PYTHON_EXAMPLE_SNIPPETS_DIR}" COMMAND "${OVITOS_EXECUTABLE}" "${test_script}")
ENDFOREACH()

# Propagate list of plugins to parent scope.
SET(OVITO_PLUGIN_LIST ${OVITO_PLUGIN_LIST} PARENT_SCOPE)

=== src/plugins/netcdf/gui/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2016) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

OVITO_STANDARD_PLUGIN(NetCDFPluginGui
	SOURCES NetCDFImporterEditor.cpp
	PLUGIN_DEPENDENCIES NetCDFPlugin ParticlesGui
	GUI_PLUGIN
)

=== src/plugins/pyscript/gui/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2016) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

FIND_PACKAGE(QScintilla REQUIRED)

SET(SourceFiles
	GUIBinding.cpp
	PythonViewportOverlayEditor.cpp
	PythonScriptModifierEditor.cpp
	RunScriptAction.cpp
	ObjectScriptEditor.cpp
)

# Compile resources.
QT5_ADD_RESOURCES(ResourceFiles resources/pyscript_gui.qrc)

OVITO_STANDARD_PLUGIN(PyScriptGui
	SOURCES ${SourceFiles} ${ResourceFiles}
	PLUGIN_DEPENDENCIES PyScript
	PRIVATE_LIB_DEPENDENCIES ${QScintilla_LIBRARIES}
	GUI_PLUGIN
	PYTHON_WRAPPERS "${CMAKE_CURRENT_SOURCE_DIR}/python/"
)

# Add QScintilla include directory.
TARGET_INCLUDE_DIRECTORIES(PyScriptGui PRIVATE ${QScintilla_INCLUDE_DIRS})

# This define is required when linking against QScintilla on Windows.
TARGET_COMPILE_DEFINITIONS(PyScriptGui PRIVATE QSCINTILLA_DLL)

# Install required libraries. 
IF(APPLE)
	# Nothing to do.
ELSEIF(UNIX)
	IF(OVITO_MONOLITHIC_BUILD)
		# Install a copy of the QScintilla2 library.
		CONFIGURE_FILE("${QScintilla_LIBRARIES}" "${OVITO_LIBRARY_DIRECTORY}" COPYONLY)		
		GET_FILENAME_COMPONENT(real_qscintilla_lib "${QScintilla_LIBRARIES}" REALPATH)
		INSTALL(FILES "${QScintilla_LIBRARIES}" "${real_qscintilla_lib}" DESTINATION "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/")
	ENDIF()
ELSEIF(WIN32)
	# Install QScintilla DLL.
	GET_FILENAME_COMPONENT(QSCINTILLA_BASE_NAME "${QScintilla_LIBRARIES}" NAME_WE)
	GET_FILENAME_COMPONENT(QSCINTILLA_LIB_PATH "${QScintilla_LIBRARIES}" PATH)
	OVITO_INSTALL_DLL("${QSCINTILLA_LIB_PATH}/${QSCINTILLA_BASE_NAME}.dll")
ENDIF()

=== src/3rdparty/voro++/examples/custom/Makefile ===
# Voro++ makefile
#
# Author : Chris H. Rycroft (LBL / UC Berkeley)
# Email  : chr@alum.mit.edu
# Date   : August 30th 2011

# Load the common configuration file
include ../../config.mk

# List of executables
EXECUTABLES=cell_statistics custom_output radical

# Makefile rules
all: $(EXECUTABLES)

cell_statistics: cell_statistics.cc
	$(CXX) $(CFLAGS) $(E_INC) $(E_LIB) -o cell_statistics cell_statistics.cc -lvoro++

custom_output: custom_output.cc
	$(CXX) $(CFLAGS) $(E_INC) $(E_LIB) -o custom_output custom_output.cc -lvoro++

radical: radical.cc
	$(CXX) $(CFLAGS) $(E_INC) $(E_LIB) -o radical radical.cc -lvoro++

clean:
	rm -f $(EXECUTABLES)

.PHONY: all clean

=== src/3rdparty/voro++/examples/extra/Makefile ===
# Voro++ makefile
#
# Author : Chris H. Rycroft (LBL / UC Berkeley)
# Email  : chr@alum.mit.edu
# Date   : August 30th 2011

# Load the common configuration file
include ../../config.mk

# List of executables
EXECUTABLES=box_cut cut_region superellipsoid irregular

# Makefile rules
all: $(EXECUTABLES)

box_cut: box_cut.cc
	$(CXX) $(CFLAGS) $(E_INC) $(E_LIB) -o box_cut box_cut.cc -lvoro++

cut_region: cut_region.cc
	$(CXX) $(CFLAGS) $(E_INC) $(E_LIB) -o cut_region cut_region.cc -lvoro++

superellipsoid: superellipsoid.cc
	$(CXX) $(CFLAGS) $(E_INC) $(E_LIB) -o superellipsoid superellipsoid.cc -lvoro++

irregular: irregular.cc
	$(CXX) $(CFLAGS) $(E_INC) $(E_LIB) -o irregular irregular.cc -lvoro++

finite_sys: finite_sys.cc
	$(CXX) $(CFLAGS) $(E_INC) $(E_LIB) -o finite_sys finite_sys.cc -lvoro++

clean:
	rm -f $(EXECUTABLES)

.PHONY: all clean

=== debian/changelog ===
ovito (2.8.1+dfsg2-5) unstable; urgency=medium

  * [eb12b49] Block tests on mips nd mips64el.

 -- Anton Gladky <gladk@debian.org>  Sun, 15 Jan 2017 16:01:02 +0100

ovito (2.8.1+dfsg2-4) unstable; urgency=medium

  * [eb599c6] Override autotest on armel und s390x

 -- Anton Gladky <gladk@debian.org>  Sun, 15 Jan 2017 10:05:07 +0100

ovito (2.8.1+dfsg2-3) unstable; urgency=medium

  [ Ghislain Antony Vaillant ]
  * [79e635e] Add missing repack settings
  * [31d5c07] Filter tarball from vendored pybind11
  * [ea3daac] Bump repack suffix
  * [4d2618b] New upstream version 2.8.1+dfsg2
  * [262c086] Use numbered patch queue
  * [7793150] Renumber current patch queue
  * [b7face1] Cherry-pick upstream fix for parallel execution of tests
  * [aec42f3] Cherry-pick upstream fix for tests for builds without
              CrystanAnalysis
  * [e1b2e36] Build with the system pybind11
              d/control: add pybind11-dev to b-deps
  * [e24b444] Drop bypass of test failures

 -- Anton Gladky <gladk@debian.org>  Sat, 14 Jan 2017 15:09:23 +0100

ovito (2.8.1+dfsg1-2) unstable; urgency=medium

  * [f0b0b49] Disable unit-test failures.

 -- Anton Gladky <gladk@debian.org>  Sun, 08 Jan 2017 18:56:50 +0100

ovito (2.8.1+dfsg1-1) unstable; urgency=medium

  [ Ghislain Antony Vaillant ]
  * [72aa97b] Fix "No files matched excluded pattern" reported by uscan
  * [8480ecd] Update watch file

  [ Anton Gladky ]
  * [2aa0adf] Remove patch applied by upstream.
  * [0a4cca5] Refresh patch.
  * [cf985df] Minor fixes in d/copyright.
  * [47c0aff] New upstream version 2.8.1+dfsg1. (Closes: #848761)

 -- Anton Gladky <gladk@debian.org>  Sun, 08 Jan 2017 15:50:21 +0100

ovito (2.8.0+dfsg2-2) unstable; urgency=medium

  * [443ab04] Disable Crystall plugin on s390x ppc64el arm64

 -- Anton Gladky <gladk@debian.org>  Sat, 10 Dec 2016 19:48:12 +0100

ovito (2.8.0+dfsg2-1) unstable; urgency=medium

  * [739dfb4] Use system qwt insteaf of embedded.
  * [6a39019] Remove embedded jquery.js.
  * [623eee4] New upstream version 2.8.0+dfsg2

 -- Anton Gladky <gladk@debian.org>  Sat, 10 Dec 2016 14:24:27 +0100

ovito (2.8.0+dfsg1-1) unstable; urgency=medium

  * [92617b4] Update/remove patches.
  * [91d0b2a] Update build dependencies.
  * [c0cfff8] Update d/copyright.
  * [6f351ea] Update d/watch
  * [0ab031b] New upstream version 2.8.0+dfsg1
  * [3e0c4ac] Apply cme fix dpkg.

 -- Anton Gladky <gladk@debian.org>  Sat, 10 Dec 2016 00:21:45 +0100

=== debian/control ===
Source: ovito
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: science
Testsuite: autopkgtest
Priority: extra
Build-Depends: cmake,
               debhelper (>= 9),
               docbook-xml,
               docbook-xsl,
               docbook-xsl-doc-html,
               libavcodec-dev,
               libavdevice-dev,
               libboost-dev,
               libboost-iostreams-dev,
               libboost-python-dev,
               libbotan1.10-dev,
               libcgal-qt5-dev [!armel],
               libglu1-mesa-dev [armel armhf],
               libgl1-mesa-dev [armel armhf],
               libgsl0-dev,
               libhdf5-dev,
               libmuparser-dev,
               libnetcdf-dev,
               libqt5scintilla2-dev,
               libqt5opengl5-dev,
               libqcustomplot-dev,
               libqwt-qt5-dev,
               libswscale-dev,
               povray,
               pybind11-dev,
               python-dev,
               python3-sphinx,
               python3-matplotlib,
               python3-sip,
               python3-numpy,
               python3-pyqt5,
               qtbase5-dev-tools,
               qtscript5-dev,
               xsltproc,
               zlib1g-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ovito.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/ovito.git
Homepage: http://www.ovito.org/

Package: ovito
Architecture: any
Depends: python,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ovito-doc
Suggests: povray
Description: visualization and analysis tool for atomistic simulation data
 OVITO is a visualization and analysis software for atomistic
 simulation data. Being a single integrated application it covers both
 the analysis and the visualization of large-scale atomistic datasets
 produced by molecular dynamics/statics and Monte-Carlo simulation
 codes. Its name is an acronym for Open Visualization Tool,
 emphasizing that the software has been designed with flexibility and
 extensibility in mind.

Package: ovito-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Suggests: ovito
Provides: ovito-examples
Description: documentation for ovito
 OVITO aka Open Visualization Tool is a scientific visualization and
 analysis software for atomistic simulation data.
 .
 This package contains the User Manual for ovito.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=qt5
%:
	dh $@ --parallel

extra_flags += \
	-DOVITO_BUILD_DOCUMENTATION=TRUE \
	-DOVITO_BUILD_PLUGIN_SCRIPTING=TRUE \
	-DOVITO_BUILD_PLUGIN_NETCDF=TRUE \
	-DOVITO_VIDEO_OUTPUT_SUPPORT=ON \
	-DOVITO_USE_SYSTEM_QCUSTOMPLOT=ON \
	-DOVITO_BUILD_PLUGIN_TACHYON=ON

ifeq (,$(filter $(DEB_HOST_ARCH), armel s390x ppc64el arm64))
	extra_flags += -DOVITO_BUILD_PLUGIN_CRYSTALANALYSIS=TRUE
else
	extra_flags += -DOVITO_BUILD_PLUGIN_CRYSTALANALYSIS=FALSE
endif

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

override_dh_install-arch:
	dh_install -a --list-missing
	find ./debian/ovito -type d -empty -delete
	find ./ -name "*DS_Store" | xargs rm -f
	find . -name '__pycache__' -print0 | xargs -0 rm -rf
	find . -name '*.pyc' -print0 | xargs -0 rm -f

override_dh_install-indep:
	dh_install -i
	dh_sphinxdoc

ifneq (,$(filter $(DEB_HOST_ARCH), armel s390x mips mips64el))
override_dh_auto_test:
	dh_auto_test || true
endif
